<?php
/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
# ***** BEGIN LICENSE BLOCK *****
# This file is part of Plume Framework, a simple PHP Application Framework.
# Copyright (C) 2001-2006 Loic d'Anterroches and contributors.
#
# Plume Framework is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or
# (at your option) any later version.
#
# Plume Framework is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# ***** END LICENSE BLOCK ***** */

$cfg = array();

// Set the debug variable to true to force the recompilation of all
// the templates each time during development
$cfg['debug'] = true;

// If your models are using models from applications outside of the
// base objects of the framework, you need to list them here. 
// You need to include the name of the current application.
$cfg['installed_apps'] = array('Pluf', 'Todo');

// Base URL of the application. Note that it is not something like
// 'root_base' not to overwrite the base of another application when
// several application are running on the same host. 
// No / at the end.
$cfg['todo_base'] = '/~loa/todo/index';

// View file of the Todo application. They can be hardcoded in the 
// Dispatcher, but it is often better to have them in a separated file
// for readability.
$cfg['todo_urls'] = dirname(__FILE__).'/urls.php';

// Temporary folder where the script is writing the compiled templates,
// cached data and other temporary resources.
// It must be writeable by your webserver instance.
// It is mandatory if you are using the template system.
$cfg['tmp_folder'] = '/tmp';

// The folder in which the templates of the application are located.
$cfg['template_folders'] = array(dirname(__FILE__).'/../templates');

// Default mimetype of the document your application is sending.
// It can be overwritten for a given response if needed.
$cfg['mimetype'] = 'text/html';

$cfg['template_tags'] = array(
                              'url' => 'Pluf_Template_Tag_Url',
                              );

// Default database configuration. The database defined here will be
// directly accessible from Pluf::db() of course it is still possible
// to open any other number of database connections through Pluf_DB
$cfg['db_login'] = '';
$cfg['db_password'] = '';
$cfg['db_server'] = '';
$cfg['db_database'] = $cfg['tmp_folder'].'/todo.db';

// Must be shared by all the installed_apps and the core framework.
// That way you can have several installations of the core framework.
$cfg['db_table_prefix'] = 'pluf_testapp_'; 

// Starting version 4.1 of MySQL the utf-8 support is "correct".
// The reason of the db_version for MySQL is only for that.
$cfg['db_version'] = '';
$cfg['db_engine'] = 'SQLite';
return $cfg;
